/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * Warning! This file is generated. Modify at your own risk.
 */

package com.google.api.services.books.model;

import com.google.api.client.json.GenericJson;
import com.google.api.client.util.DateTime;

/**
 * Model definition for Annotationdata.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Books API. For a detailed explanation see:
 * <a href="http://code.google.com/p/google-api-java-client/wiki/Json">http://code.google.com/p/google-api-java-client/wiki/Json</a>
 * </p>
 *
 * <p>
 * Upgrade warning: starting with version 1.12 {@code getResponseHeaders()} is removed, instead use
 * {@link com.google.api.client.http.json.JsonHttpRequest#getLastResponseHeaders()}
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class Annotationdata extends GenericJson {

  /**
   * The type of annotation this data is for.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String annotationType;

  /**
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private Object data;

  /**
   * Base64 encoded data for this annotation data.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key("encoded_data")
  private String encodedData;

  /**
   * Unique id for this annotation data.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String id;

  /**
   * Resource Type
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String kind;

  /**
   * The Layer id for this data. *
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String layerId;

  /**
   * URL for this resource. *
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String selfLink;

  /**
   * Timestamp for the last time this data was updated. (RFC 3339 UTC date-time format).
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private DateTime updated;

  /**
   * The volume id for this data. *
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String volumeId;

  /**
   * The type of annotation this data is for.
   * The value returned may be {@code null}.
   */
  public String getAnnotationType() {
    return annotationType;
  }

  /**
   * The type of annotation this data is for.
   * The value set may be {@code null}.
   */
  public Annotationdata setAnnotationType(String annotationType) {
    this.annotationType = annotationType;
    return this;
  }

  /**

   * The value returned may be {@code null}.
   */
  public Object getData() {
    return data;
  }

  /**

   * The value set may be {@code null}.
   */
  public Annotationdata setData(Object data) {
    this.data = data;
    return this;
  }

  /**
   * Base64 encoded data for this annotation data.
   * The value returned may be {@code null}.
   */
  public String getEncodedData() {
    return encodedData;
  }

  /**
   * Base64 encoded data for this annotation data.
   * The value set may be {@code null}.
   */
  public Annotationdata setEncodedData(String encodedData) {
    this.encodedData = encodedData;
    return this;
  }

  /**
   * Unique id for this annotation data.
   * The value returned may be {@code null}.
   */
  public String getId() {
    return id;
  }

  /**
   * Unique id for this annotation data.
   * The value set may be {@code null}.
   */
  public Annotationdata setId(String id) {
    this.id = id;
    return this;
  }

  /**
   * Resource Type
   * The value returned may be {@code null}.
   */
  public String getKind() {
    return kind;
  }

  /**
   * Resource Type
   * The value set may be {@code null}.
   */
  public Annotationdata setKind(String kind) {
    this.kind = kind;
    return this;
  }

  /**
   * The Layer id for this data. *
   * The value returned may be {@code null}.
   */
  public String getLayerId() {
    return layerId;
  }

  /**
   * The Layer id for this data. *
   * The value set may be {@code null}.
   */
  public Annotationdata setLayerId(String layerId) {
    this.layerId = layerId;
    return this;
  }

  /**
   * URL for this resource. *
   * The value returned may be {@code null}.
   */
  public String getSelfLink() {
    return selfLink;
  }

  /**
   * URL for this resource. *
   * The value set may be {@code null}.
   */
  public Annotationdata setSelfLink(String selfLink) {
    this.selfLink = selfLink;
    return this;
  }

  /**
   * Timestamp for the last time this data was updated. (RFC 3339 UTC date-time format).
   * The value returned may be {@code null}.
   */
  public DateTime getUpdated() {
    return updated;
  }

  /**
   * Timestamp for the last time this data was updated. (RFC 3339 UTC date-time format).
   * The value set may be {@code null}.
   */
  public Annotationdata setUpdated(DateTime updated) {
    this.updated = updated;
    return this;
  }

  /**
   * The volume id for this data. *
   * The value returned may be {@code null}.
   */
  public String getVolumeId() {
    return volumeId;
  }

  /**
   * The volume id for this data. *
   * The value set may be {@code null}.
   */
  public Annotationdata setVolumeId(String volumeId) {
    this.volumeId = volumeId;
    return this;
  }

}
