/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * Warning! This file is generated. Modify at your own risk.
 */

package com.google.api.services.books.model;

import com.google.api.client.json.GenericJson;

/**
 * Model definition for BooksAnnotationsRange.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Books API. For a detailed explanation see:
 * <a href="http://code.google.com/p/google-api-java-client/wiki/Json">http://code.google.com/p/google-api-java-client/wiki/Json</a>
 * </p>
 *
 * <p>
 * Upgrade warning: starting with version 1.12 {@code getResponseHeaders()} is removed, instead use
 * {@link com.google.api.client.http.json.JsonHttpRequest#getLastResponseHeaders()}
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class BooksAnnotationsRange extends GenericJson {

  /**
   * The offset from the ending position.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String endOffset;

  /**
   * The ending position for the range.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String endPosition;

  /**
   * The offset from the starting position.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String startOffset;

  /**
   * The starting position for the range.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String startPosition;

  /**
   * The offset from the ending position.
   * The value returned may be {@code null}.
   */
  public String getEndOffset() {
    return endOffset;
  }

  /**
   * The offset from the ending position.
   * The value set may be {@code null}.
   */
  public BooksAnnotationsRange setEndOffset(String endOffset) {
    this.endOffset = endOffset;
    return this;
  }

  /**
   * The ending position for the range.
   * The value returned may be {@code null}.
   */
  public String getEndPosition() {
    return endPosition;
  }

  /**
   * The ending position for the range.
   * The value set may be {@code null}.
   */
  public BooksAnnotationsRange setEndPosition(String endPosition) {
    this.endPosition = endPosition;
    return this;
  }

  /**
   * The offset from the starting position.
   * The value returned may be {@code null}.
   */
  public String getStartOffset() {
    return startOffset;
  }

  /**
   * The offset from the starting position.
   * The value set may be {@code null}.
   */
  public BooksAnnotationsRange setStartOffset(String startOffset) {
    this.startOffset = startOffset;
    return this;
  }

  /**
   * The starting position for the range.
   * The value returned may be {@code null}.
   */
  public String getStartPosition() {
    return startPosition;
  }

  /**
   * The starting position for the range.
   * The value set may be {@code null}.
   */
  public BooksAnnotationsRange setStartPosition(String startPosition) {
    this.startPosition = startPosition;
    return this;
  }

}
