/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * Warning! This file is generated. Modify at your own risk.
 */

package com.google.api.services.books.model;

import com.google.api.client.json.GenericJson;
import com.google.api.client.util.DateTime;

/**
 * Model definition for Volumeannotation.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Books API. For a detailed explanation see:
 * <a href="http://code.google.com/p/google-api-java-client/wiki/Json">http://code.google.com/p/google-api-java-client/wiki/Json</a>
 * </p>
 *
 * <p>
 * Upgrade warning: starting with version 1.12 {@code getResponseHeaders()} is removed, instead use
 * {@link com.google.api.client.http.json.JsonHttpRequest#getLastResponseHeaders()}
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class Volumeannotation extends GenericJson {

  /**
   * The annotation data id for this volume annotation.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String annotationDataId;

  /**
   * Link to get data for this annotation.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String annotationDataLink;

  /**
   * The type of annotation this is.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String annotationType;

  /**
   * The content ranges to identify the selected text.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private ContentRanges contentRanges;

  /**
   * Data for this annotation.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String data;

  /**
   * Indicates that this annotation is deleted.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private Boolean deleted;

  /**
   * Unique id of this volume annotation.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String id;

  /**
   * Resource Type
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String kind;

  /**
   * The Layer this annotation is for.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String layerId;

  /**
   * Pages the annotation spans.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<String> pageIds;

  /**
   * Excerpt from the volume.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String selectedText;

  /**
   * URL to this resource.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String selfLink;

  /**
   * Timestamp for the last time this anntoation was updated. (RFC 3339 UTC date-time format).
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private DateTime updated;

  /**
   * The Volume this annotation is for.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String volumeId;

  /**
   * The annotation data id for this volume annotation.
   * The value returned may be {@code null}.
   */
  public String getAnnotationDataId() {
    return annotationDataId;
  }

  /**
   * The annotation data id for this volume annotation.
   * The value set may be {@code null}.
   */
  public Volumeannotation setAnnotationDataId(String annotationDataId) {
    this.annotationDataId = annotationDataId;
    return this;
  }

  /**
   * Link to get data for this annotation.
   * The value returned may be {@code null}.
   */
  public String getAnnotationDataLink() {
    return annotationDataLink;
  }

  /**
   * Link to get data for this annotation.
   * The value set may be {@code null}.
   */
  public Volumeannotation setAnnotationDataLink(String annotationDataLink) {
    this.annotationDataLink = annotationDataLink;
    return this;
  }

  /**
   * The type of annotation this is.
   * The value returned may be {@code null}.
   */
  public String getAnnotationType() {
    return annotationType;
  }

  /**
   * The type of annotation this is.
   * The value set may be {@code null}.
   */
  public Volumeannotation setAnnotationType(String annotationType) {
    this.annotationType = annotationType;
    return this;
  }

  /**
   * The content ranges to identify the selected text.
   * The value returned may be {@code null}.
   */
  public ContentRanges getContentRanges() {
    return contentRanges;
  }

  /**
   * The content ranges to identify the selected text.
   * The value set may be {@code null}.
   */
  public Volumeannotation setContentRanges(ContentRanges contentRanges) {
    this.contentRanges = contentRanges;
    return this;
  }

  /**
   * Data for this annotation.
   * The value returned may be {@code null}.
   */
  public String getData() {
    return data;
  }

  /**
   * Data for this annotation.
   * The value set may be {@code null}.
   */
  public Volumeannotation setData(String data) {
    this.data = data;
    return this;
  }

  /**
   * Indicates that this annotation is deleted.
   * The value returned may be {@code null}.
   */
  public Boolean getDeleted() {
    return deleted;
  }

  /**
   * Indicates that this annotation is deleted.
   * The value set may be {@code null}.
   */
  public Volumeannotation setDeleted(Boolean deleted) {
    this.deleted = deleted;
    return this;
  }

  /**
   * Unique id of this volume annotation.
   * The value returned may be {@code null}.
   */
  public String getId() {
    return id;
  }

  /**
   * Unique id of this volume annotation.
   * The value set may be {@code null}.
   */
  public Volumeannotation setId(String id) {
    this.id = id;
    return this;
  }

  /**
   * Resource Type
   * The value returned may be {@code null}.
   */
  public String getKind() {
    return kind;
  }

  /**
   * Resource Type
   * The value set may be {@code null}.
   */
  public Volumeannotation setKind(String kind) {
    this.kind = kind;
    return this;
  }

  /**
   * The Layer this annotation is for.
   * The value returned may be {@code null}.
   */
  public String getLayerId() {
    return layerId;
  }

  /**
   * The Layer this annotation is for.
   * The value set may be {@code null}.
   */
  public Volumeannotation setLayerId(String layerId) {
    this.layerId = layerId;
    return this;
  }

  /**
   * Pages the annotation spans.
   * The value returned may be {@code null}.
   */
  public java.util.List<String> getPageIds() {
    return pageIds;
  }

  /**
   * Pages the annotation spans.
   * The value set may be {@code null}.
   */
  public Volumeannotation setPageIds(java.util.List<String> pageIds) {
    this.pageIds = pageIds;
    return this;
  }

  /**
   * Excerpt from the volume.
   * The value returned may be {@code null}.
   */
  public String getSelectedText() {
    return selectedText;
  }

  /**
   * Excerpt from the volume.
   * The value set may be {@code null}.
   */
  public Volumeannotation setSelectedText(String selectedText) {
    this.selectedText = selectedText;
    return this;
  }

  /**
   * URL to this resource.
   * The value returned may be {@code null}.
   */
  public String getSelfLink() {
    return selfLink;
  }

  /**
   * URL to this resource.
   * The value set may be {@code null}.
   */
  public Volumeannotation setSelfLink(String selfLink) {
    this.selfLink = selfLink;
    return this;
  }

  /**
   * Timestamp for the last time this anntoation was updated. (RFC 3339 UTC date-time format).
   * The value returned may be {@code null}.
   */
  public DateTime getUpdated() {
    return updated;
  }

  /**
   * Timestamp for the last time this anntoation was updated. (RFC 3339 UTC date-time format).
   * The value set may be {@code null}.
   */
  public Volumeannotation setUpdated(DateTime updated) {
    this.updated = updated;
    return this;
  }

  /**
   * The Volume this annotation is for.
   * The value returned may be {@code null}.
   */
  public String getVolumeId() {
    return volumeId;
  }

  /**
   * The Volume this annotation is for.
   * The value set may be {@code null}.
   */
  public Volumeannotation setVolumeId(String volumeId) {
    this.volumeId = volumeId;
    return this;
  }

  /**
   * The content ranges to identify the selected text.
   */
  public static final class ContentRanges extends GenericJson {

    /**
     * Range in CFI format for this annotation for version above.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private BooksAnnotationsRange cfiRange;

    /**
     * Content version applicable to ranges below.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private String contentVersion;

    /**
     * Range in GB image format for this annotation for version above.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private BooksAnnotationsRange gbImageRange;

    /**
     * Range in GB text format for this annotation for version above.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private BooksAnnotationsRange gbTextRange;

    /**
     * Range in CFI format for this annotation for version above.
     * The value returned may be {@code null}.
     */
    public BooksAnnotationsRange getCfiRange() {
      return cfiRange;
    }

    /**
     * Range in CFI format for this annotation for version above.
     * The value set may be {@code null}.
     */
    public ContentRanges setCfiRange(BooksAnnotationsRange cfiRange) {
      this.cfiRange = cfiRange;
      return this;
    }

    /**
     * Content version applicable to ranges below.
     * The value returned may be {@code null}.
     */
    public String getContentVersion() {
      return contentVersion;
    }

    /**
     * Content version applicable to ranges below.
     * The value set may be {@code null}.
     */
    public ContentRanges setContentVersion(String contentVersion) {
      this.contentVersion = contentVersion;
      return this;
    }

    /**
     * Range in GB image format for this annotation for version above.
     * The value returned may be {@code null}.
     */
    public BooksAnnotationsRange getGbImageRange() {
      return gbImageRange;
    }

    /**
     * Range in GB image format for this annotation for version above.
     * The value set may be {@code null}.
     */
    public ContentRanges setGbImageRange(BooksAnnotationsRange gbImageRange) {
      this.gbImageRange = gbImageRange;
      return this;
    }

    /**
     * Range in GB text format for this annotation for version above.
     * The value returned may be {@code null}.
     */
    public BooksAnnotationsRange getGbTextRange() {
      return gbTextRange;
    }

    /**
     * Range in GB text format for this annotation for version above.
     * The value set may be {@code null}.
     */
    public ContentRanges setGbTextRange(BooksAnnotationsRange gbTextRange) {
      this.gbTextRange = gbTextRange;
      return this;
    }

  }

}
